'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lr = require('@lezer/lr');
var language = require('@codemirror/language');
var autocomplete = require('@codemirror/autocomplete');
var view = require('@codemirror/view');
var highlight = require('@lezer/highlight');
var state = require('@codemirror/state');
var lint = require('@codemirror/lint');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_word = {__proto__:null,true:80, false:82, null:84, starts:94, with:96, ends:98, contains:100, matches:102, not:104, in:106, and:108, or:110};
const spec_Operator = {__proto__:null,"!":113, "+":115, "-":117};
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "(pOVQPOOQ!QQPOOO!{QPO'#CdO$]QPO'#CmO$dQPO'#CnOVQPO'#CtOVQPO'#CvOOQO'#C|'#C|O$kQPO'#CcO$pQPO'#CcOOQO'#Ck'#CkOOQO'#Cl'#ClOOQO'#Cu'#CuO$uQPO,58xOVQPO,58|OVQPO,59[OVQPO,59]O$zQPO'#CrOOQO'#Cr'#CrO%PQPO'#CrO%}QPO,59XOOQO,59X,59XO&UQPO'#DSO&cQPO,59YO&hQPO,59`O'OQPO,59bO'VQPO'#CeOOQO,58},58}O'VQPO'#ChO'^QPO'#CaOOQO1G.d1G.dOOQO1G.l1G.lO(nQPO1G.hO(uQPO1G.vO(|QPO1G.wOOQO,59^,59^OVQPO1G.sOVQPO'#CwO)dQPO,59nOOQO1G.t1G.tOOQO1G.|1G.|O)oQPO,59PO)tQPO,59SOOQO7+$S7+$SOVQPO7+$bO)yQPO7+$_O*TQPO,59cOOQO-E6u-E6uOOQO1G.k1G.kOOQO1G.n1G.nO*bQPO<<G|OVQPO'#CxO*xQPO<<GyOOQO<<Gy<<GyO+QQPO,59dOOQO-E6v-E6vOOQOAN=eAN=eOVQPO1G/OO+XQPO7+$j",
  stateData: "+k~OoOS~O]VO^VOqQOsSOuUOxYOyYOzZO|RO!U[O!Y[O!Z[O![[O~OR]OS]Og`Os^O!O_O!PaO!RaO!SbO!TbO!UcO!VbO!WbO!XbO~ORcXScXgcXmcXscXuWX!OcX!PcX!RcX!ScX!TcX!UcX!VcX!WcX!XcX}cXrcXwcXtcX{cX~O{eO~PVOrvP~PVOujO~OulO~OqmO~O!QsO~O!VsO]fX^fXqfXsfXufXxfXyfXzfX|fX!UfX!YfX!ZfX![fX~O}tO~P!QOwuOrvXtvX~P!QOrwO~Omha}harhawhatha{ha~P!QOtxO~P!QOtvP~PVORTXSTXgTXmTXsTXuZX!OTX!PTX!RTX!STX!TTX!UTX!VTX!WTX!XTX}TXrTXwTXtTX{TX~Or{O~P!QO}|O~P!QOmei}eireiweitei{ei~P!QOwuOrvatva~Ot!QO~Ot!RO~Ow!TO{!VO~P!QOrkawkatka~P!QOmdy}dyrdywdytdy{dy~P!QOw!TO{!YO~O}!ZO~P!QOwlq{lq~P!QO^gRS]qS~",
  goto: "%]wPPxPP!Zxx!^!o!r#T#WPPxxxxxxx#ZPx#jx#{$RPPP$XPPPPP%SoVORSTU^_`jltu|!T!ZRn]oWORSTU^_`jltu|!T!ZRkWoXORSTU^_`jltu|!T!ZRo]RkXk`Pdfhipqr}!O!S!W![oTORSTU^_`jltu|!T!ZQvfR!PvQ!U}R!X!UQPOQdRUfSjlQhTQiUQp^Qq_Qr`Q}tQ!OuQ!S|Q!W!TR![!ZQgSQyjRzl",
  nodeNames: "⚠ Expression ObjectAccess MemberOf NullSafeMemberOf Property ArrayAccess Call Function Arguments ObjectAccess Method Arguments Number String Boolean Null Object Array Variable TernaryExpression BinaryExpression OperatorKeyword Operator UnaryExpression UnaryOperator Application",
  maxTerm: 58,
  skippedNodes: [0],
  repeatNodeCount: 2,
  tokenData: ",l~RqXY#YYZ#Y]^#Ypq#Yqr#krs$Quv#{vw%zwx&Sxy'wyz'|z{(R{|#{|}(Z}!O#{!O!P(`!P!Q#{!Q![(h![!]*}!^!_#s!_!`+S!`!a#s!a!b+Y!c!}+m!}#O,O#P#Q,T#Q#R#{#R#S+m#T#o+m#o#p,Y#p#q,_#q#r,g#r#s#{~#_So~XY#YYZ#Y]^#Ypq#Y~#pPg~!_!`#s~#xPg~!_!`#{~$QOg~~$TXOr$Qrs$ps#O$Q#O#P$u#P;'S$Q;'S;=`%t<%l~$Q~O$Q~~$p~$uO^~~$xRO;'S$Q;'S;=`%R;=`O$Q~%UYOr$Qrs$ps#O$Q#O#P$u#P;'S$Q;'S;=`%t;=`<%l$Q<%l~$Q~O$Q~~$p~%wP;=`<%l$Q~&PPg~vw#{~&VXOw&Swx$px#O&S#O#P&r#P;'S&S;'S;=`'q<%l~&S~O&S~~$p~&uRO;'S&S;'S;=`'O;=`O&S~'RYOw&Swx$px#O&S#O#P&r#P;'S&S;'S;=`'q;=`<%l&S<%l~&S~O&S~~$p~'tP;=`<%l&S~'|Ou~~(ROt~~(WPg~z{#{~(`Ow~~(ePR~!O!P#{~(mT]~!O!P(|!Q![(h!g!h)|#R#S*w#X#Y)|~)PSO!O)]!P;'S)];'S;=`*q<%lO)]~)bR]~!Q![)k!g!h)|#X#Y)|~)pS]~!Q![)k!g!h)|#R#S*k#X#Y)|~*PR{|*Y}!O*Y!Q![*`~*]P!Q![*`~*eQ]~!Q![*`#R#S*Y~*nP!Q![)k~*tP;=`<%l)]~*zP!Q![(h~+SO}~~+VP!_!`#s~+_R!O~!O!P+h![!]#{!a!b#{~+mOS~~+rSq~!Q![+m!c!}+m#R#S+m#T#o+m~,TOs~~,YOr~~,_O|~~,dPg~#p#q#{~,lO{~",
  tokenizers: [0],
  topRules: {"Expression":[0,1]},
  specialized: [{term: 33, get: (value) => spec_word[value] || -1},{term: 23, get: (value) => spec_Operator[value] || -1}],
  tokenPrec: 479
});

const autocompleteFunction = (x) => {
    var _a, _b;
    return ({
        label: `${x.name}(${((_a = x.args) === null || _a === void 0 ? void 0 : _a.join(',')) || ''})`,
        apply: (view, completion, from, to) => {
            var _a;
            view.dispatch(Object.assign(Object.assign({}, autocomplete.insertCompletionText(view.state, `${x.name}()`, from, to)), { selection: { anchor: from + x.name.length + (((_a = x.args) === null || _a === void 0 ? void 0 : _a.length) > 0 ? 1 : 2) } }));
        },
        detail: (_b = x.returnType) === null || _b === void 0 ? void 0 : _b.join('|'),
        info: x.info, type: "function"
    });
};
const autocompleteIdentifier = (x) => { var _a; return ({ label: x.name, apply: x.name, info: x.info, detail: x.detail || ((_a = x.type) === null || _a === void 0 ? void 0 : _a.join('|')), type: 'variable' }); };
const resolveCallable = (identifier, config) => { var _a; return (_a = config === null || config === void 0 ? void 0 : config.functions) === null || _a === void 0 ? void 0 : _a.find(x => x.name === identifier); };
const resolveIdentifier = (nodeName, identifier, config) => {
    var _a;
    switch (nodeName) {
        case 'Method':
        case 'Function':
            return resolveCallable(identifier, config);
        case 'Property':
        case 'Variable':
            return (_a = config === null || config === void 0 ? void 0 : config.identifiers) === null || _a === void 0 ? void 0 : _a.find(x => x.name === identifier);
    }
};
const cursorTooltipBaseTheme = view.EditorView.baseTheme({
    ".cm-tooltip.cm-tooltip-cursor": {
        boxShadow: 'rgba(0, 0, 0, .15) 0 1px 2px',
        border: "1px solid rgba(127, 127, 127, .2)",
        padding: "2px 7px",
        borderRadius: "4px",
        "& .cm-tooltip-arrow:before": {},
        "& .cm-tooltip-arrow:after": {
            borderTopColor: "transparent"
        }
    }
});
function getNodeOrdinal(node) {
    let ordinal = -1;
    for (let c = node; c; c = c.prevSibling, ordinal++)
        ;
    return ordinal;
}
function resolveArguments(node) {
    let c = node;
    while (c && c.name !== 'Arguments') {
        c = c.parent;
    }
    return c;
}
function resolveFunctionDefinition(node, state, config) {
    var _a;
    if (!node) {
        return undefined;
    }
    let identifier;
    if (node.name === 'ObjectAccess' && node.lastChild) {
        const leftArgument = (_a = node.firstChild) === null || _a === void 0 ? void 0 : _a.node;
        const types = Array.from(resolveTypes(state, leftArgument, config));
        identifier = state.sliceDoc(node.lastChild.from, node.lastChild.to);
        return types.map(type => { var _a; return resolveCallable(identifier, (_a = config.types) === null || _a === void 0 ? void 0 : _a[type]); }).find(x => x);
    }
    else if (node.name === 'Function') {
        identifier = state.sliceDoc(node.from, node.node.firstChild ? node.node.firstChild.from - 1 : node.to);
        return resolveCallable(identifier, config);
    }
}
function getCursorTooltips(state, config) {
    // @ts-ignore
    return state.selection.ranges
        .filter(range => range.empty)
        .map(range => {
        var _a;
        const tree = language.syntaxTree(state);
        const node = tree.resolveInner(range.from, 0);
        const args = resolveArguments(node);
        if (!args || !args.prevSibling) {
            return null;
        }
        const fn = resolveFunctionDefinition(args.prevSibling, state, config);
        if (!fn) {
            return null;
        }
        const n = args.childAfter(range.from - 1);
        const argName = (_a = fn.args) === null || _a === void 0 ? void 0 : _a[n ? getNodeOrdinal(n) : 0];
        if (n && n.from !== range.from || !argName) {
            return null;
        }
        return {
            pos: range.head,
            above: true,
            strictSide: false,
            arrow: true,
            create: () => {
                let dom = document.createElement("div");
                dom.className = "cm-tooltip-cursor";
                dom.textContent = `${argName}`;
                return { dom };
            },
        };
    }).filter(x => x);
}
const cursorTooltipField = (config) => state.StateField.define({
    create: (state) => getCursorTooltips(state, config),
    update(tooltips, tr) {
        if (!tr.docChanged && !tr.selection) {
            return tooltips;
        }
        return getCursorTooltips(tr.state, config);
    },
    provide: f => view.showTooltip.computeN([f], state => state.field(f))
});
const expressionLanguageLinterSource = (config) => (state) => {
    let diagnostics = [];
    language.syntaxTree(state).cursor().iterate(node => {
        var _a, _b, _c, _d, _e, _f, _g;
        const { from, to, name } = node;
        let identifier;
        switch (name) {
            case '⚠':
                if (state.doc.length === 0 || from === 0) {
                    // Don't show error on empty doc (even though it is an error)
                    return;
                }
                identifier = state.sliceDoc(from, to);
                if (identifier.length === 0) {
                    diagnostics.push({ from, to: (_c = (_b = (_a = node.node.parent) === null || _a === void 0 ? void 0 : _a.parent) === null || _b === void 0 ? void 0 : _b.to) !== null && _c !== void 0 ? _c : to, severity: 'error', message: `Expression expected` });
                }
                else {
                    const type = /^[a-zA-Z_]+[a-zA-Z_0-9]*$/.test(identifier) ? 'identifier' : 'operator';
                    diagnostics.push({ from, to, severity: 'error', message: `Unexpected ${type} '${identifier}'` });
                }
                return;
            case 'Arguments':
                const args = (_d = resolveFunctionDefinition(node.node.prevSibling, state, config)) === null || _d === void 0 ? void 0 : _d.args;
                if (!args) {
                    return;
                }
                let i = 0;
                let n = node.node.firstChild;
                while (n) {
                    if (++i > args.length) {
                        diagnostics.push({ from: n.from, to: n.to, severity: 'error', message: `Unexpected argument` });
                    }
                    n = n.nextSibling;
                }
                break;
            case 'Property':
            case 'Method':
                const leftArgument = (_f = (_e = node.node.parent) === null || _e === void 0 ? void 0 : _e.firstChild) === null || _f === void 0 ? void 0 : _f.node;
                const types = Array.from(resolveTypes(state, leftArgument, config));
                identifier = state.sliceDoc(from, to);
                if (!types.find(type => { var _a; return resolveIdentifier(name, identifier, (_a = config.types) === null || _a === void 0 ? void 0 : _a[type]); })) {
                    diagnostics.push({ from, to, severity: 'error', message: `${node.name} "${identifier}" not found in ${types.join('|')}` });
                }
                break;
            case 'Variable':
            case 'Function':
                identifier = state.sliceDoc(from, node.node.firstChild ? node.node.firstChild.from - 1 : to);
                if (!resolveIdentifier(name, identifier, config)) {
                    diagnostics.push({ from, to, severity: 'error', message: `${node.node.name} "${identifier}" not found` });
                }
                break;
        }
        if (identifier && ((_g = node.node.parent) === null || _g === void 0 ? void 0 : _g.type.isError)) {
            diagnostics.push({ from, to, severity: 'error', message: `Unexpected identifier "${identifier}"` });
        }
    });
    return diagnostics;
};
const expressionLanguageLinter = (config) => lint.linter(view => expressionLanguageLinterSource(config)(view.state));
const keywordTooltip = (config) => view.hoverTooltip((view, pos, side) => {
    var _a, _b, _c, _d, _e, _f;
    const tree = language.syntaxTree(view.state).resolveInner(pos, side);
    if (!['Function', 'Variable', 'Method', 'Property'].includes(tree.name)) {
        return null;
    }
    const skipEmpty = (x) => x;
    let info;
    if (((_a = tree.parent) === null || _a === void 0 ? void 0 : _a.firstChild) && ((_b = tree.parent) === null || _b === void 0 ? void 0 : _b.name) === 'ObjectAccess' && tree.prevSibling) {
        const node = tree.parent.firstChild;
        const types = Array.from(resolveTypes(view.state, node, config));
        const name = view.state.sliceDoc(tree.from, tree.to);
        info = [
            ...types.map(type => { var _a, _b, _c, _d; return (_d = (_c = (_b = (_a = config.types) === null || _a === void 0 ? void 0 : _a[type]) === null || _b === void 0 ? void 0 : _b.identifiers) === null || _c === void 0 ? void 0 : _c.find(x => x.name === name)) === null || _d === void 0 ? void 0 : _d.info; }).filter(skipEmpty),
            ...types.map(type => { var _a, _b, _c, _d; return (_d = (_c = (_b = (_a = config.types) === null || _a === void 0 ? void 0 : _a[type]) === null || _b === void 0 ? void 0 : _b.functions) === null || _c === void 0 ? void 0 : _c.find(x => x.name === name)) === null || _d === void 0 ? void 0 : _d.info; }).filter(skipEmpty),
        ].join('\n');
    }
    else {
        const name = view.state.sliceDoc(tree.from, tree.to);
        info = [
            ...[(_d = (_c = config.identifiers) === null || _c === void 0 ? void 0 : _c.find(x => x.name === name)) === null || _d === void 0 ? void 0 : _d.info].filter(skipEmpty),
            ...[(_f = (_e = config.functions) === null || _e === void 0 ? void 0 : _e.find(x => x.name === name)) === null || _f === void 0 ? void 0 : _f.info].filter(skipEmpty),
        ].join('\n');
    }
    if (!info) {
        return null;
    }
    return {
        pos: tree.from,
        end: tree.to,
        above: true,
        create(view) {
            const dom = document.createElement("div");
            dom[config.htmlTooltip ? 'innerHTML' : 'textContent'] = info;
            dom.className = 'cm-diagnostic';
            return { dom };
        },
    };
});
const ELLanguage = language.LRLanguage.define({
    parser: parser.configure({
        props: [
            language.indentNodeProp.add({
                Application: language.delimitedIndent({ closing: ")", align: false }),
                Arguments: language.delimitedIndent({ closing: ")", align: false }),
                Object: language.delimitedIndent({ closing: "}", align: false }),
            }),
            language.foldNodeProp.add({
                Application: ({ from, to }) => ({ from: from + 1, to: to - 1 }),
                Arguments: ({ from, to }) => ({ from: from + 1, to: to - 1 }),
                Object: ({ from, to }) => ({ from: from + 1, to: to - 1 }),
            }),
            highlight.styleTags({
                Property: highlight.tags.propertyName,
                Variable: highlight.tags.variableName,
                Function: highlight.tags.function(highlight.tags.variableName),
                Method: highlight.tags.function(highlight.tags.propertyName),
                Boolean: highlight.tags.bool,
                String: highlight.tags.string,
                Number: highlight.tags.number,
                '(': highlight.tags.paren,
                ')': highlight.tags.paren,
                '[': highlight.tags.squareBracket,
                ']': highlight.tags.squareBracket,
                ',': highlight.tags.punctuation,
                MemberOf: highlight.tags.punctuation,
                NullSafeMemberOf: highlight.tags.punctuation,
                OperatorKeyword: highlight.tags.operatorKeyword,
                UnaryOperator: highlight.tags.operator,
                Operator: highlight.tags.operator,
            })
        ]
    }),
    languageData: {}
});
function completeOperatorKeyword(state, config, tree, from, to, explicit) {
    var _a, _b;
    return {
        from,
        to,
        options: (_b = (_a = config.operatorKeywords) === null || _a === void 0 ? void 0 : _a.map(({ name, info, detail }) => ({ label: name, apply: `${name} `, info, detail, type: "keyword" }))) !== null && _b !== void 0 ? _b : [],
        validFor: (text) => { var _a, _b; return (_b = (_a = config.operatorKeywords) === null || _a === void 0 ? void 0 : _a.some(({ name }) => explicit || name.includes(text))) !== null && _b !== void 0 ? _b : false; },
    };
}
function completeIdentifier(state, config, tree, from, to) {
    var _a, _b;
    const identifiers = (_a = config.identifiers) !== null && _a !== void 0 ? _a : []; //?.filter(({ name }) => explicit || name.toLowerCase().startsWith(text)) ?? [];
    const functions = (_b = config.functions) !== null && _b !== void 0 ? _b : []; //?.filter(({ name }) => explicit || name.toLowerCase().startsWith(text)) ?? [];
    return {
        from,
        to,
        options: [...(identifiers.map(autocompleteIdentifier)), ...(functions.map(autocompleteFunction))],
        validFor: /^[a-zA-Z_]+[a-zA-Z_0-9]*$/,
    };
}
function resolveTypes(state, node, config, matchExact) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    let types = new Set();
    if (!node) {
        return types;
    }
    if (node.name === 'Call' && node.firstChild && node.lastChild) {
        resolveTypes(state, node.firstChild, config).forEach(x => types.add(x));
    }
    else if (node.name === 'Variable') {
        const varName = state.sliceDoc(node.from, node.to) || '';
        // @ts-ignore
        (_b = (_a = resolveIdentifier(node.name, varName, config)) === null || _a === void 0 ? void 0 : _a.type) === null || _b === void 0 ? void 0 : _b.forEach((x) => types.add(x));
    }
    else if (node.name === 'Function') {
        const varName = state.sliceDoc(node.from, node.to) || '';
        // @ts-ignore
        (_d = (_c = resolveIdentifier(node.name, varName, config)) === null || _c === void 0 ? void 0 : _c.returnType) === null || _d === void 0 ? void 0 : _d.forEach((x) => types.add(x));
    }
    else if (node.name === 'ObjectAccess' && node.firstChild && ((_e = node.lastChild) === null || _e === void 0 ? void 0 : _e.name) === 'Property') {
        const varName = state.sliceDoc(node.lastChild.from, node.lastChild.to) || '';
        (_f = resolveTypes(state, node.firstChild, config)) === null || _f === void 0 ? void 0 : _f.forEach(baseType => {
            var _a, _b, _c, _d;
            // @ts-ignore
            (_d = (_c = resolveIdentifier((_a = node.lastChild) === null || _a === void 0 ? void 0 : _a.name, varName, (_b = config.types) === null || _b === void 0 ? void 0 : _b[baseType])) === null || _c === void 0 ? void 0 : _c.type) === null || _d === void 0 ? void 0 : _d.forEach((x) => types.add(x));
        });
    }
    else if (node.name === 'ObjectAccess' && node.firstChild && ((_g = node.lastChild) === null || _g === void 0 ? void 0 : _g.name) === 'Method') {
        const varName = state.sliceDoc(node.lastChild.from, node.lastChild.to) || '';
        (_h = resolveTypes(state, node.firstChild, config)) === null || _h === void 0 ? void 0 : _h.forEach(baseType => {
            var _a, _b, _c, _d;
            // @ts-ignore
            (_d = (_c = resolveIdentifier((_a = node.lastChild) === null || _a === void 0 ? void 0 : _a.name, varName, (_b = config.types) === null || _b === void 0 ? void 0 : _b[baseType])) === null || _c === void 0 ? void 0 : _c.returnType) === null || _d === void 0 ? void 0 : _d.forEach((x) => types.add(x));
        });
    }
    else if (node.name === 'Application' && node.firstChild) {
        resolveTypes(state, node.firstChild, config).forEach(x => types.add(x));
    }
    if (types.size === 0) {
        types.add('any');
    }
    return types;
}
function completeMember(state, config, tree, from, to, explicit) {
    var _a, _b, _c, _d;
    if (((_a = tree.parent) === null || _a === void 0 ? void 0 : _a.name) != 'ObjectAccess' || !tree.parent.firstChild) {
        return null;
    }
    state.sliceDoc(from, to);
    const types = resolveTypes(state, tree.parent.firstChild.node, config);
    if (!(types === null || types === void 0 ? void 0 : types.size)) {
        return null;
    }
    let options = [];
    for (const type of types) {
        const typeDeclaration = (_b = config.types) === null || _b === void 0 ? void 0 : _b[type];
        options.push(...(((_c = typeDeclaration === null || typeDeclaration === void 0 ? void 0 : typeDeclaration.identifiers) === null || _c === void 0 ? void 0 : _c.map(autocompleteIdentifier)) || []), ...(((_d = typeDeclaration === null || typeDeclaration === void 0 ? void 0 : typeDeclaration.functions) === null || _d === void 0 ? void 0 : _d.map(autocompleteFunction)) || []));
    }
    return {
        from,
        to,
        options,
        validFor: /^[a-zA-Z_]+[a-zA-Z_0-9]*$/,
    };
}
function expressionLanguageCompletionFor(config, context) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    const { state, pos, explicit } = context;
    const tree = language.syntaxTree(state);
    const prevNode = tree.resolveInner(pos, state.sliceDoc(pos - 1, pos) === ')' ? 0 : -1);
    const isIdentifier = (node) => { var _a; return ['Variable', 'Function'].includes((_a = node === null || node === void 0 ? void 0 : node.name) !== null && _a !== void 0 ? _a : ''); };
    const isMember = (node) => { var _a; return ['Property', 'Method'].includes((_a = node === null || node === void 0 ? void 0 : node.name) !== null && _a !== void 0 ? _a : ''); };
    if (prevNode.name == 'String') {
        return null;
    }
    if (((_a = prevNode.parent) === null || _a === void 0 ? void 0 : _a.name) == 'ObjectAccess' && ['ObjectAccess', 'ArrayAccess', 'Variable', 'Call'].includes(((_b = prevNode.parent.firstChild) === null || _b === void 0 ? void 0 : _b.name) || '')) {
        return completeMember(state, config, prevNode, isIdentifier(prevNode) || isMember(prevNode) ? prevNode.from : pos, pos);
    }
    if (['Expression', 'UnaryExpression', 'BinaryExpression', 'TernaryExpression'].includes(prevNode.name) && prevNode.lastChild && !((_c = prevNode.lastChild) === null || _c === void 0 ? void 0 : _c.type.isError)
        || ['Arguments', 'Array'].includes(prevNode.name) && prevNode.lastChild && !((_d = prevNode.lastChild) === null || _d === void 0 ? void 0 : _d.type.isError)
        || ['Expression', 'UnaryExpression', 'BinaryExpression', 'TernaryExpression'].includes((_f = (_e = prevNode.parent) === null || _e === void 0 ? void 0 : _e.name) !== null && _f !== void 0 ? _f : '') && prevNode.type.isError
        || ['Variable', 'Function'].includes((_h = (_g = prevNode.parent) === null || _g === void 0 ? void 0 : _g.name) !== null && _h !== void 0 ? _h : '') && prevNode.type.isError) {
        return completeOperatorKeyword(state, config, prevNode, !['Expression', 'UnaryExpression', 'BinaryExpression', 'TernaryExpression', 'Arguments'].includes(prevNode.name) ? prevNode.from : pos, pos, explicit);
    }
    if (['Expression', 'UnaryExpression', 'BinaryExpression', 'TernaryExpression'].includes(prevNode.name) && ((_j = prevNode.lastChild) === null || _j === void 0 ? void 0 : _j.type.isError)
        || ['Expression', 'UnaryExpression', 'BinaryExpression', 'TernaryExpression', 'Arguments'].includes((_l = (_k = prevNode.parent) === null || _k === void 0 ? void 0 : _k.name) !== null && _l !== void 0 ? _l : '') && !prevNode.type.isError
        || ['Arguments', 'Array'].includes((_m = prevNode.name) !== null && _m !== void 0 ? _m : '')) {
        return completeIdentifier(state, config, prevNode, isIdentifier(prevNode) ? prevNode.from : pos, pos);
    }
    return null;
}
function expressionLanguageCompletionSourceWith(config) {
    var _a;
    (_a = config.operatorKeywords) !== null && _a !== void 0 ? _a : (config.operatorKeywords = [
        { name: 'starts with' },
        { name: 'ends with' },
        { name: 'contains' },
        { name: 'matches' },
        { name: 'not in' },
        { name: 'in' },
        { name: 'not' },
        { name: 'or' },
        { name: 'and' },
    ]);
    return (context) => expressionLanguageCompletionFor(config, context);
}
function expressionlanguage(config = {}, extensions = []) {
    return new language.LanguageSupport(ELLanguage, [
        ELLanguage.data.of({ autocomplete: expressionLanguageCompletionSourceWith(config) }),
        expressionLanguageLinter(config),
        keywordTooltip(config),
        ...extensions,
        [cursorTooltipField(config), cursorTooltipBaseTheme],
    ]);
}

exports.ELLanguage = ELLanguage;
exports.expressionLanguageLinterSource = expressionLanguageLinterSource;
exports.expressionlanguage = expressionlanguage;
exports.keywordTooltip = keywordTooltip;
